<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="../style.css" type="text/css">
<link rel="icon" type="image/png" href="icon.png">
<title>SSH recommendations</title>
<body>
<h1>azarus' page</h1>
<h2>SSH recommendations</h2>
<p>Date: 2018-09-06</p>
<p>I realized how inconvenient and what a hassle it is to use ssh with its
default settings, so here's what I use to save my fingers from typing lots.
<h2>ssh-agent</h2>
<p>You certainly use public-key based authentiation in SSH with locally
encrypted keys <i>(right?)</i>. If you're wondering how people keep sane when
entering their key password multiple times daily: <b>They don't.</b> They
use ssh-agent, which is provided with OpenSSH. To make it start and be the same
across all your shell sessions, here's a fragment of my ~/.kshrc:</p>
<pre>
export SSH_AUTH_SOCK=~/.ssh/ssh-agent.sock
ssh-add -l 2&lt;/dev/null &gt;dev/null
if [ $? -ge 2 ]; then
	ssh-agent -a "$SSH_AUTH_SOCK" &gt;/dev/null
fi
</pre>
<p>To make ssh-agent add your keys when you first use them in the session, add
this in your ~/.ssh/config:</p>
<pre>
AddKeysToAgent yes
</pre>
<h2>SSH multiplexing</h2>
<p>SSH connections take a while to establish, and waiting for things to happen
is just so... <i>80s</i>. So the clever folks who invented and wrote the SSH
protocol added a handy feature: <b>multiplexed connections.</b></p>
<p>When using a multiplexed connection, any subsequent connection is initialized
almost instantaneously, since there is no need for:
<ul>
	<li>DNS lookup (possibly even a timely reverse one)</li>
	<li>Establishing a TCP connection</li>
	<li>Authentication</li>
</ul>
And thus, multiplexing is very handy for when you want to use multiple or many
SSH sessions subsequently. To enable them (which I recommend), add to
~/.ssh/config:</p>
<pre>
ControlMaster auto
ControlPath ~/.ssh/cm-%r@%h:%p
ControlPersist 10m
</pre>
<h2>Note</h2>
<p>Everything described here is also (of course) documented in the
<a href="https://man.openbsd.org/ssh">ssh man page</a> <i>(also see the "see
also" <a href="https://man.openbsd.org/ssh#SEE_ALSO">section</a>)</i> provided
with OpenSSH.</p>
<footer>
<hr>
<p>Unless otherwise noted, this content is <a href="https://creativecommons.org/publicdomain/zero/1.0/">
publicly licensed (CC0)</a>.</p>
<p>This website is served by the <a href="https://man.openbsd.org/httpd">httpd</a> daemon, running on OpenBSD 6.3.</p>
</footer>
</body>
</html>
